#include <iostream>
#include <vector>
#include <deque>
// #include <set>
#include <algorithm>
#include <cmath>
// #include <queue>

using namespace std;


int main() {

	int n;
    int o, a, b, ab;

    int po = 0, pa = 0, pb = 0, pab = 0;
    int co, ca, cb, cab;


    cin >> n;
    cin >> o >> a >> b >> ab;


    co = o;
    ca = a;
    cb = b;
    cab = ab;

    vector<pair<string, int>> pacijenti;

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int br;
        cin >> br;

        pacijenti.push_back(make_pair(s, br));

        if (s == "A")
            pa += br;
        else if (s == "B")
            pb += br;
        else if (s == "O")
            po += br;
        else
            pab += br;
    }

    int zbir = o + a + b + ab;
    int zbir_p = po + pa + pb + pab;

    if (zbir_p > zbir) {
        cout << "nemoguce" << endl;
        return 0;
    }

    if (po > o) {
        cout << "nemoguce" << endl;
        return 0;
    } else {
        o -= po;
        po = 0;
    }

    if (pa <= a) {
        a -= pa;
        pa = 0;
    } else {
        pa = pa - a;
        a = 0;
        if (pa > o) {
            cout << "nemoguce";
            return 0;
        } else {
            o -= pa;
            pa = 0;
        }
    }



    if (pb <= b) {
        b -= pb;
        pb = 0;
    } else {
        pb = pb - b;
        b = 0;
        if (pb > o) {
            cout << "nemoguce";
            return 0;
        } else {
            o -= pb;
            pb = 0;
        }
    }

    if (pab > o + a + b + ab) {
        cout << "nemoguce";
        return 0;
    }

    cout << "moguce" << endl;
    for (int i = 0; i < n; i++) {


        if (pacijenti[i].first == "A") {
            if (pacijenti[i].second > ca) {
                cout << pacijenti[i].second - ca << " " << ca << " 0 0" << endl;
                co -= pacijenti[i].second - ca;
                ca = 0;
            } else {
                cout << "0 " << pacijenti[i].second << " 0 0" << endl;
                ca -= pacijenti[i].second;
            }
        } else if (pacijenti[i].first == "B") {
            if (pacijenti[i].second > cb) {
                cout << pacijenti[i].second - cb << " 0 " << cb << " 0" << endl;
                co -= pacijenti[i].second - cb;
                cb = 0;
            } else {
                cout << "0 0 " << pacijenti[i].second << " 0" << endl;
                cb -= pacijenti[i].second;
            }
        } else if (pacijenti[i].first == "O") {
            cout << pacijenti[i].second << " 0 0 0" << endl;
            co -= pacijenti[i].second;
        } else {
            int pcs = pacijenti[i].second;
            if (o >= pcs) {
                cout << pcs << " 0 0 0" << endl;
                o -= pcs;
            } else if (o + a >= pcs) {
                cout << o << " " << pcs - o << " 0 0" << endl;
                o = 0;
                a -= pcs - o;
            } else if (o + a + b >= pcs) {
                cout << o << " " << a << " " << pcs - o - a << " 0" << endl;
                o = 0;
                a = 0;
                b -= pcs - o - a;
            } else {    
                cout << o << " " << a << " " << b << " " << pcs - o - a - b << endl;
                o = 0;
                a = 0;
                b = 0;
                ab -= pcs - o - a - b;
            }

        }

    }


	return 0;
}